Index: libpri.h
===================================================================
RCS file: /usr/cvsroot/libpri/libpri.h,v
retrieving revision 1.35
diff -u -r1.35 libpri.h
--- libpri.h	27 Oct 2004 20:43:23 -0000	1.35
+++ libpri.h	30 Oct 2004 19:39:00 -0000
@@ -253,6 +253,7 @@
 	int e;
 	int channel;
 	int cref;
+	int progress;
 	q931_call *call;
 } pri_event_ringing;
 
@@ -260,6 +261,7 @@
 	int e;
 	int channel;
 	int cref;
+	int progress;
 	q931_call *call;
 } pri_event_answer;
 
@@ -309,6 +311,9 @@
 typedef struct pri_event_proceeding {
 	int e;
 	int channel;
+	int cref;
+	int progress;
+	q931_call *call;
 } pri_event_proceeding;
  
 typedef struct pri_event_setup_ack {
Index: q931.c
===================================================================
RCS file: /usr/cvsroot/libpri/q931.c,v
retrieving revision 1.92
diff -u -r1.92 q931.c
--- q931.c	29 Oct 2004 15:41:59 -0000	1.92
+++ q931.c	30 Oct 2004 19:39:01 -0000
@@ -2686,6 +2686,7 @@
 		pri->ev.ringing.channel = c->channelno | (c->ds1no << 8);
 		pri->ev.ringing.cref = c->cr;
 		pri->ev.ringing.call = c;
+		pri->ev.ringing.progress = c->progress;
 		return Q931_RES_HAVEEVENT;
 	case Q931_CONNECT:
 		if (c->newcall) {
@@ -2702,6 +2703,7 @@
 		pri->ev.answer.channel = c->channelno | (c->ds1no << 8);
 		pri->ev.answer.cref = c->cr;
 		pri->ev.answer.call = c;
+		pri->ev.answer.progress = c->progress;
 		q931_connect_acknowledge(pri, c);
 		return Q931_RES_HAVEEVENT;
 	case Q931_FACILITY:
@@ -2745,6 +2747,10 @@
 			c->ourcallstate = Q931_CALL_STATE_OUTGOING_CALL_PROCEEDING;
 			c->peercallstate = Q931_CALL_STATE_INCOMING_CALL_PROCEEDING;
 		}
+		else
+			pri->ev.proceeding.progress = c->progress;
+		pri->ev.proceeding.cref = c->cr;
+		pri->ev.proceeding.call = c;
 		return Q931_RES_HAVEEVENT;
 	case Q931_CONNECT_ACKNOWLEDGE:
 		if (c->newcall) {
